<?php

/**
 * @author 
 * @copyright 2008
 */
 
clearstatcache() ;
$cache_modified = array();
$cache_old = strtotime("-1 days");
$d = dir($local_files);
echo "<!-- EPG cache path " . $d->path . " -->\n";
while (false !== ($entry = $d->read()))
{
  if (substr($entry, 11) != "epg_cache")
  {
    continue;
  }
  $cache_date = substr($entry, 0, 10);
  $cache_modified[$cache_date] = filemtime($local_files . DIRECTORY_SEPARATOR . $entry);
  echo "<!-- EPG cache file " . $entry . " : " . date("D d M", $cache_date) . " : " . date("r", $cache_modified[$cache_date]) .
    " -->\n";
  //echo "<!-- EPG cache file " . $entry . " : " . date("r", filectime($local_files . DIRECTORY_SEPARATOR . $entry)) . " : " . date("r", fileatime($local_files . DIRECTORY_SEPARATOR . $entry)) . " -->\n";
  $deleting = ($cache_date < $cache_old);
  if ($deleting)
  {
    echo "<!-- EPG cache deleting " . $entry . " -->\n";
    if (!unlink($local_files . DIRECTORY_SEPARATOR . $entry))
    {
      echo "<!-- EPG cache delete failed " . $local_files . DIRECTORY_SEPARATOR . $entry . " -->\n";
    }
  }
}
$d->close();

//echo "<!-- EPG cache dates " . date("r", $current_date) . " > " . date("r", find_midnight(strtotime  ("now") - 6 * 60 * 60)) . " -->\n";
//echo "<!-- EPG cache dates " . date("r", $current_date) . " > " . date("r", find_midnight(strtotime  ("+1 days") - 6 * 60 * 60)) . " -->\n";
//echo "<!-- EPG cache dates " . date("r", $current_date) . " > " . date("r", find_midnight(strtotime  ("+2 days") - 6 * 60 * 60)) . " -->\n";
if ($current_date == find_midnight(strtotime("now") - 6 * 60 * 60))
{
  $cache_expiry = strtotime("-$cache_epg_today minutes");
} elseif ($current_date == find_midnight(strtotime("+1 days") - 6 * 60 * 60))
{
  $cache_expiry = strtotime("-$cache_epg_tomorrow minutes");
} else
{
  $cache_expiry = strtotime("-$cache_epg_beyond minutes");
}
echo "<!-- EPG cache compare " . date("r", $cache_modified[$current_date]) . " > " . date("r", $cache_expiry) .
  " -->\n";
if ($cache_modified[$current_date] > $cache_expiry)
{
  $use_current_cache = true;
  echo "<!-- EPG cache " . $current_date . "_epg_cache" . " has not expired and will be used -->\n";
} else
{
  $use_current_cache = false;
  echo "<!-- EPG cache " . $current_date . "_epg_cache" . " has expired or does not exist -->\n";
  if ($retain_pids) // Read the old cache to match as many pids as possible

  {
    $epg_cache_expired = unserialize($get_cache = file_get_contents($local_files . DIRECTORY_SEPARATOR .
      $current_date . "_epg_cache"));
  }
}

function retain_old_pidtable($expired)
{
  global $result, $pid_table, $last_pid;

	echo "<!-- EPG cache retaining old pid entries -->\n" ;
  $pidtable_expired = $expired["pidtable"];
  $last_pid = $expired["last_pid"];
  foreach ($result as $index => $prog)
  {
    $prog["pid"] = 0;
    foreach ($pidtable_expired as $pid => $pidentry)
    {
      if ($pidentry["epgChannel"] === $prog["epgChannel"] && $pidentry["epgStart"] === $prog["epgStart"] && $pidentry["epgTitle"]
        === $prog["epgTitle"])
      {
        $pid_table[$pid] = $pidentry; // retain the pid details
        $pid_table[$pid]["index"] = $index; // point the pid at the programme
        $result[$index]["pid"] = $prog["pid"] = $pid; // point the programmme at the pid
        break;
      }
    }
    if ($prog["pid"] == 0) // no match was found

    {
      // add a new pid entry
      $result[$index]["pid"] = ++$last_pid; // point the programm at the new pid
      $pid_table[$last_pid]["index"] = $index; // point the new pid at the programme
      $pid_table[$last_pid]["epgChannel"] = $prog["epgChannel"];
      $pid_table[$last_pid]["epgStart"] = $prog["epgStart"];
      $pid_table[$last_pid]["epgTitle"] = $prog["epgTitle"];
    }
  }
}

function build_new_pidtable()
{
  global $result, $pid_table, $last_pid;

	echo "<!-- EPG cache building new pid table -->\n" ;	
  //print_r($result);
  $last_pid = 0;
  foreach ($result as $index => $prog)
  {
    // add a new pid entry
    $result[$index]["pid"] = ++$last_pid; // point the programm at the new pid
    $pid_table[$last_pid]["index"] = $index; // point the new pid at the programme
    $pid_table[$last_pid]["epgChannel"] = $prog["epgChannel"];
    $pid_table[$last_pid]["epgStart"] = $prog["epgStart"];
    $pid_table[$last_pid]["epgTitle"] = $prog["epgTitle"];
  }
  //print_r($pid_table);
}

?>